HDU 2845(dp)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2845

Beans

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 3097    Accepted Submission(s):
1495

Problem Description

Bean-eating is an interesting game, everyone owns an
M*N matrix, which is filled with different qualities beans. Meantime, there is
only one bean in any 1*1 grid. Now you want to eat the beans and collect the
qualities, but everyone must obey by the following rules: if you eat the bean at
the coordinate(x, y), you can’t eat the beans anyway at the coordinates listed
(if exiting): (x, y-1), (x, y+1), and the both rows whose abscissas are x-1 and
x+1.

Now,
how much qualities can you eat and then get ?

Input

There are a few cases. In each case, there are two
integer M (row number) and N (column number). The next M lines each contain N
integers, representing the qualities of the beans. We can make sure that the
quality of bean isn‘t beyond 1000, and 1<=M*N<=200000.

Output

For each case, you just output the MAX qualities you
can eat and then get.

Sample Input

4 6
11 0 7 5 13 9
78 4 81 6 22 4
1 40 9 34 16 10
11 22 0 33 39 6

Sample Output

242

题意:按照规则取出的数字和最大。规则:取了坐标为(x,y)的数字就不能再取坐标为(x,y-1)、(x,y+1)、(x-1,*)和(x+1,*)的数字,*表示任意位置。

分析:首先找出每一行每个位置和最佳情况;每个数字可取可不取,即:dpx[i] = max(dpx[i-1], dpx[i-2] + 该行第 i 个数字)。然后再找列的和最佳情况,此时只有一列,即每一行的最大值组成的列,则:dyp[i] = max(dpy[i-1], dpy[i-2] + 第 i 行的最大值)。

 1 #include <cstdio>
 2 #include <cmath>
 3 #include <iostream>
 4 using namespace std;
 5
 6 int n,m,s;
 7 int dpx[222222],dpy[222222];
 8
 9 int main ()
10 {
11     int i,j,k;
12     while (scanf ("%d%d",&n,&m)==2)
13     {
14         memset(dpx, 0, sizeof(dpx));
15         memset(dpy, 0, sizeof(dpy));//先对两个数组清零
16         for (i=2; i<=n+1; i++)
17         {
18             for (j=2; j<=m+1; j++)
19             {
20                 scanf ("%d",&s);
21                 dpx[j] = max(dpx[j-1], dpx[j-2] + s);//每个状态的值等于之前的某个状态加上另一个状态
22             }
23             dpy[i] = max(dpy[i-1], dpy[i-2] + dpx[m+1]);//因为只有加法,dpx[m+1]为每一行的最大值
24         }
25         printf ("%d\n",dpy[n+1]);
26     }
27     return 0;
28 }

时间: 2024-10-25 06:32:37

HDU 2845(dp)的相关文章

HDU 1506 &amp;&amp; HDU1505 &amp;&amp; HDU 2870 (DP).

~~~~ 这三道DP题是逐层递进的,大家可以从前往后做. 题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1506 http://acm.hdu.edu.cn/showproblem.php?pid=1505 http://acm.hdu.edu.cn/showproblem.php?pid=2870 ~~~~ 1506: 分别找每一块板子的可以的最左边界和最右边界,注意这时不能用两个for暴力(显然会TLE),所以要用DP的思想边搜边保存. 另外注

hdu 1025(DP)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1025 Constructing Roads In JGShining's Kingdom Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 15902    Accepted Submission(s): 4537 Problem Descr

hdu 1158(dp)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1158 Employment Planning Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 3654    Accepted Submission(s): 1502 Problem Description A project manage

HDU 5800 (DP)

Problem To My Girlfriend (HDU 5800) 题目大意 给定一个由n个元素组成的序列,和s (n<=1000,s<=1000) 求 :   f (i,j,k,l,m) 指必定选第i,j号元素,必定不选k,l号元素,选的元素总和为m的子集个数. 解题分析 一开始想了个n^3的DP,f[j][k]表示选j个数总和为k的方案数,然后一直想着怎么去优化,陷进死胡同,到比赛结束还没想出来. 看了题解后,感觉智商被藐视了. 题解的做法是f[i][j][s1][s2]表示前i个数总

饭卡 HDU - 2546(dp)

电子科大本部食堂的饭卡有一种很诡异的设计,即在购买之前判断余额.如果购买一个商品之前,卡上的剩余金额大于或等于5元,就一定可以购买成功(即使购买后卡上余额为负),否则无法购买(即使金额足够).所以大家都希望尽量使卡上的余额最少. 某天,食堂中有n种菜出售,每种菜可购买一次.已知每种菜的价格以及卡上的余额,问最少可使卡上的余额为多少. Input多组数据.对于每组数据: 第一行为正整数n,表示菜的数量.n<=1000. 第二行包括n个正整数,表示每种菜的价格.价格不超过50. 第三行包括一个正整数

hdu 5155(DP)

题目连接:http://acm.hdu.edu.cn/showproblem.php?pid=5155 Harry And Magic Box Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 273    Accepted Submission(s): 137 Problem Description One day, Harry got

HDU 4489(DP)

http://acm.hdu.edu.cn/showproblem.php?pid=4489 解题思路这里已经说的很清楚了: http://blog.csdn.net/bossup/article/details/9915647 这里就说下遇到这种问题应该怎么想. 因为是排列问题,一般都是从某个点开始推,寻找限制条件,但这道题不一样,因为每个数据都是不同的. 所以这时就要找边界条件,要么从最高点入手,要么从最低点入手. 以最高点为例,在任意一个点j放置最高点. 由题意可以知道两端的排列情况,前面

hdu 1024(dp)

传送门:Max Sum Plus Plus 题意:从n个数中选出m段不相交的连续子段,求这个和最大. 分析:经典dp,dp[i][j][0]表示不取第i个数且前i个数分成j段达到的最优值,dp[i][j][1]表示取了第i个数且前i个数分成j段达到的最优值. 那么有: dp[i][j][0]=max(dp[i-1][j][0],dp[i-1][j][1]). dp[i][j][1]=max(dp[i-1][j-1][0]+a[i],max(dp[i-1][j-1][1],dp[i][j][1])

HDU 2577(DP)

题意:要求一个字符串输入,按键盘的最少次数.有Caps Lock和Shift两种转换大小写输入的方式 思路:用dpa与dpb数组分别记录Caps Lock的开关状态,dpa表示不开,dpb表示开 代码: #include <stdio.h> #include <string.h> #include <algorithm> using namespace std; char str[111]; int dpa[111],dpb[111]; int main() { int